<template>
    <div class="container-fluid">
      <div class="row ">
        <div class="col-12">
          <div class="card mx-auto col-sm-8" style="margin: 2% 0 0; padding: 50px;">
            <h2 class="auth-title mb-4">Inscription</h2>
            <br>

            <div class="p-5" v-if="isLoading">
              <fulfilling-bouncing-circle-spinner
                class="mx-auto"
                :animation-duration="2000"
                :size="60"
                :color="'#005C96'"
              />
            </div>
            <div v-else>
              <div class="alert alert-danger" v-if="errorMessage">
                {{ errorMessage }}
              </div>

              <form @submit="register">
                <div class="row">
                  <!-- agence -->
                  <div class="col-12 form-group">
                    <label class="">Nom</label>
                    <input  type="text" class="form-control"
                      v-model="newAdmin.lastname"  placeholder="Nom" required />
                  </div>
                  <!-- client -->
                  <div class="col-12 form-group">
                    <label class="">Prénom(s)</label>
                    <input type="text" class="form-control"
                      v-model="newAdmin.firstname"  placeholder="Nom" required />
                  </div>
                  <div class="col-12 form-group">
                    <label class="">Profession</label>
                    <input type="text" class="form-control"
                      v-model="newAdmin.profession" placeholder="Profession" required  />
                  </div>
                  <div class="col-12 form-group">
                    <label class="">Email</label>
                    <input type="text" class="form-control"
                      v-model="newAdmin.email" placeholder="Nom" required />
                  </div>
                  <div class="col-12 form-group">
                    <label class="">Mot de passe</label>
                    <input type="password" class="form-control"
                      v-model="newAdmin.password" placeholder="Mot de passe" required/>
                  </div>
                  <div class="col-12 form-group">
                    <label> Confirmer le Mot de passe</label>
                    <input type="password" class="form-control"
                      v-model="confpassword" placeholder="Confirmer mot de passe" required />
                  </div>
                  <div class="col-sm-12" v-for="(file, i) in importFiles" :key="i">
                    <div class="form-group">
                      <label for="photo">{{i == 0 ? 'Photo de profil' : 'Fichier ' + (i+1)}}</label>
                      <div :class="'custom-file' + (imageData[i] ? ' filled' : '')">
                        <div
                          class="img-preview"
                          :style="'background-image: url(' + imageData[i] + ')'"
                        ></div>
                        <input
                          type="file"
                          class="custom-file-input"
                          :id="'customFile' + i"
                          :ref="'file' + i"
                          @change="handleFileUpload(i)"
                        />
                        <label
                          class="custom-file-label"
                          :for="'customFile' + i"
                        >{{ file.name || 'Choisir une photo'}}</label>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="form-group col-sm-4 mx-auto mt-1">
                  <input type="submit" class="btn btn-light btn-block" value="Valider" />
                </div>
              </form>
              <div class="form-group text-center">
                <router-link class="text-manote" to="/login">
                  Vous avez deja un compte ? <br /> Connectez vous !</router-link>
              </div>
            </div>
          </div>
        </div>

      </div>
      
    </div>
</template>

<script>
import Pays from "./users/country";

export default {
  name: "Register",
  data() {
    return {
      newAdmin: {
        email:'',
        password:'',
        firstname:'',
        lastname:'',
        profession:'',
      },
      confpassword: "",
      errorMessage: "",
      // welcomeMail: {},
      // position: { },
      isLoading: false,

      importFiles: [],
      imageData: [],
      fileNumber: 1,
    };
  },
  mounted() {
    // this.geolocate();
    for (var i = 0; i < this.fileNumber; i++) {
      this.importFiles.push({});
      this.imageData.push("");
    }
  },
  methods: {
    register(e) {
      e.preventDefault();
      this.isLoading = true;

      if (this.newAdmin.password == this.confpassword) { 

        let formData = new FormData();
        formData.append("fileprop", "pictures");
        formData.append("filenumber", this.fileNumber);
        formData.append("objectdata", JSON.stringify(this.newAdmin));

        for (var i = 0; i < this.fileNumber; i++) {
          if (this.importFiles[i].name) {
            formData.append("filedata" + i, this.importFiles[i]);
          }
        }

        this.$service.registerAdminWithFile(formData, (err, data) => {
          this.isLoading = true;
          if (err) {this.errorMessage = err.data && err.data.message;console.log("Error", err.data);return;}
          this.$swal.fire("Enrégistrement effectué !", "", "success").then(() => {
            this.$router.push({ path: "/login" });  
          });
        });
      } else {
        this.errorMessage = "Confirmation mot de passe échouée.";
      }
    },
    handleFileUpload(index) {
      console.log(this.$refs["file" + index][0]);
      this.importFiles[index] = this.$refs["file" + index][0].files[0];
      if (this.importFiles[index]) {
        const reader = new FileReader();
        reader.onload = (e) => {
          this.imageData[index] = e.target.result;
          this.$forceUpdate();
        };
        reader.readAsDataURL(this.importFiles[index]);
      }
      this.$forceUpdate();
    },
  },
};
</script>
